{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends '@KnpMenu/menu.html.twig' %}
{% import '@KnpMenu/menu.html.twig' as knp_menu %}

{% block list %}
    {% if item.hasChildren and options.depth is not same as(0) and item.displayChildren %}
        {%- set class = item.parent ? 'dropdown-menu' : 'nav navbar-nav' %}
        {%- set listAttributes = listAttributes|merge({'class': (listAttributes.class|default('') ~ ' ' ~ class)|trim }) %}
        {{ parent() }}
    {% endif %}
{% endblock %}

{% block item %}
    {% if item.displayed %}
        {# building the class of the item #}
        {%- set classes = item.attribute('class') is not empty ? [item.attribute('class')] : [] %}
        {%- if matcher.isCurrent(item) %}
            {%- set classes = classes|merge([options.currentClass]) %}
        {%- elseif matcher.isAncestor(item, options.matchingDepth) %}
            {%- set classes = classes|merge([options.ancestorClass]) %}
        {%- endif %}
        {%- if item.actsLikeFirst %}
            {%- set classes = classes|merge([options.firstClass]) %}
        {%- endif %}
        {%- if item.actsLikeLast %}
            {%- set classes = classes|merge([options.lastClass]) %}
        {%- endif %}

        {# Mark item as "leaf" (no children) or as "branch" (has children that are displayed) #}
        {% if item.hasChildren and options.depth is not same as(0) %}
            {% if options.branch_class is not empty and item.displayChildren %}
                {%- set classes = classes|merge([options.branch_class]) %}
            {% endif %}
        {% elseif options.leaf_class is not empty %}
            {%- set classes = classes|merge([options.leaf_class]) %}
        {%- endif %}

        {%- set attributes = item.attributes %}
        {%- if classes is not empty %}
            {%- set attributes = attributes|merge({'class': classes|join(' ')}) %}
        {%- endif %}

        {%- if item.displayChildren and item.children|length > 0 -%}
            {%- set attributes = attributes|merge({'class': (attributes.class|default('') ~ ' dropdown')|trim }) %}
        {%- endif -%}

        {# displaying the item #}
        {%- if item.extras.divider is defined and (item.extras.divider == 'prepend' or item.extras.divider == 'both') %}
            {{ block('dividerElement') }}
        {%- endif %}
        <li{{ knp_menu.attributes(attributes) }}>
            {%- if item.uri is not empty and (not matcher.isCurrent(item) or options.currentAsLink) %}
                {{ block('linkElement') }}
            {%- else %}
                {{ block('spanElement') }}
            {%- endif %}
            {# render the list of children#}
            {%- set childrenClasses = item.childrenAttribute('class') is not empty ? [item.childrenAttribute('class')] : [] %}
            {%- set childrenClasses = childrenClasses|merge(['menu_level_' ~ item.level]) %}
            {%- set listAttributes = item.childrenAttributes|merge({'class': childrenClasses|join(' ') }) %}
            {{ block('list') }}
        </li>
        {%- if item.extras.divider is defined and (item.extras.divider == 'append' or item.extras.divider == 'both') %}
            {{ block('dividerElement') }}
        {%- endif %}
    {% endif %}
{% endblock %}

{%- block linkElement -%}
    {%- set linkAttributes = item.linkAttributes -%}
    {%- set isDropdown = item.displayChildren and item.children|length > 0 -%}
    {%- if isDropdown -%}
        {%- set linkAttributes = linkAttributes|merge({'class': (linkAttributes.class|default('') ~ ' dropdown-toggle')|trim, 'data-toggle': 'dropdown' }) %}
    {%- endif -%}
    <a href="{{ item.uri }}"{{ knp_menu.attributes(linkAttributes) }}>
        {%- if item.extras.icon is defined -%}
            <i class="{{ item.extras.icon }}"></i> &nbsp;
        {%- endif -%}
        {{- block('label') -}}
        {%- if isDropdown -%}
            &nbsp;<span class="caret"></span>
        {%- endif -%}
    </a>
{%- endblock -%}

{% block dividerElement %}
    {% if item.level == 1 %}
        <li class="divider-vertical"></li>
    {% else %}
        <li class="divider"></li>
    {% endif %}
{% endblock %}
